import React, { useState } from 'react';
import classNames from 'classnames';
import { CSSTransition } from 'react-transition-group';
import Icon from '../icon';
var prefixCls = 'nami-alert';
var Alert = function (props) {
    var _a = useState(true), visible = _a[0], setVisible = _a[1];
    var message = props.message, className = props.className, shape = props.shape, _b = props.type, type = _b === void 0 ? 'default' : _b, buttonText = props.buttonText, linkText = props.linkText, onClose = props.onClose, onClick = props.onClick;
    var handleClose = function () {
        setVisible(false);
        onClose && onClose();
    };
    var handleClick = function () {
        onClick && onClick();
    };
    var renderType = function () {
        var types = {
            closeable: (React.createElement("span", { className: prefixCls + "-icon", onClick: handleClose },
                React.createElement(Icon, { type: '\uE69B' }))),
            link: (React.createElement("span", { className: prefixCls + "-link" },
                linkText && React.createElement("span", { className: prefixCls + "-link-text" }, linkText),
                React.createElement(Icon, { type: '\uE69A' }))),
            button: React.createElement("span", { className: prefixCls + "-btn" }, buttonText),
            default: null
        };
        return types[type];
    };
    var renderAlert = function () {
        var _a;
        var alertCls = classNames(prefixCls, (_a = {},
            _a[prefixCls + "-circle"] = shape === 'circle',
            _a), className);
        return (React.createElement("div", { className: alertCls, onClick: handleClick },
            React.createElement("p", { className: prefixCls + "-message", "data-testid": 'alert' }, message),
            renderType()));
    };
    return (React.createElement(CSSTransition, { in: visible, timeout: 100, unmountOnExit: true, classNames: prefixCls }, renderAlert()));
};
Alert.defaultProps = {
    type: 'default',
    message: '',
    buttonText: '去开启'
};
export default Alert;
