import React, { Fragment, useEffect } from 'react';
import ReactDOM from 'react-dom';
import { CSSTransition } from 'react-transition-group';
import BodyScroll from '@bairong/body-scroll';
var prefixCls = 'nami-slide-left-panel';
var maskCls = prefixCls + "-mask";
var PANEL_WHITH = window.innerWidth * 0.65;
var PANEL_HEIGHT = window.innerHeight;
var node = document.createElement('div');
document.body.appendChild(node);
var SlideleftPanel = function (props) {
    var visible = props.visible, children = props.children, onClose = props.onClose, maskClosable = props.maskClosable;
    useEffect(function () { return function () {
        BodyScroll['abled']();
        document.body.removeChild(node);
    }; }, []);
    useEffect(function () {
        BodyScroll[visible ? 'disabled' : 'abled']();
    }, [visible]);
    var handleMaskClick = function () {
        maskClosable && onClose && onClose();
    };
    var renderBody = function () { return (React.createElement("div", { className: "" + prefixCls, style: { height: PANEL_HEIGHT, width: PANEL_WHITH }, "data-testid": 'SlideleftPanel' }, children)); };
    var renderMask = function () { return (React.createElement("div", { className: maskCls, onClick: handleMaskClick, "data-testid": 'mask' })); };
    var renderSlideUpPanel = function () { return (React.createElement(Fragment, null,
        React.createElement(CSSTransition, { in: visible, timeout: 300, unmountOnExit: true, classNames: prefixCls }, renderBody()),
        React.createElement(CSSTransition, { in: visible, timeout: 300, unmountOnExit: true, classNames: maskCls }, renderMask()))); };
    return ReactDOM.createPortal(renderSlideUpPanel(), node);
};
SlideleftPanel.defaultProps = {
    visible: false,
    maskClosable: true
};
export default SlideleftPanel;
